/*
    TCFbENeighbor.h    June 6, 2004.

    Copyright (C) 2003-2004 CFbE Research Group,
    Software Engineering Laboratory,
    Graduate School of Information Science,
    Nara Institute of Science and Technology,
    All rights reserved.

    This program is free software; you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2, (at your option) or
    any later version.

    This program is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with GNU Emacs; see the file COPYING.  If not, write to the
    Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/
//---------------------------------------------------------------------------
#ifndef TCFbENeighborH
#define TCFbENeighborH
//---------------------------------------------------------------------------
#include <system.hpp>
#include <Contnrs.hpp>
#include "TCFbEToolkit.h"
//---------------------------------------------------------------------------
class TCFbENeighbor : public TObject
{
public:
    virtual __fastcall TCFbENeighbor(AnsiString Label, double Similarity, double Value, double SourceValue);    // コンストラクタ
    __fastcall ~TCFbENeighbor();    // デストラクタ

    static double __fastcall GetAverageValueOfNeighborList(TObjectList* NeighborList);    // NeighborList に格納された Neighbors の値の平均値を返す
    static double __fastcall GetMedianValueOfNeighborList(TObjectList* NeighborList);    // NeighborList に格納された Neighbors の値の中間値を返す

    // アクセサ
    AnsiString  GetLabel(void) { return this->FLabel; }
    double      GetSimilarity(void) { return this->FSimilarity; }
    double      GetValue(void) { return this->FValue; }
    double      GetSourceValue(void) { return this->FSourceValue; }
    
protected:
    AnsiString    FLabel;
    double    FSimilarity;
    double    FValue;
    double    FSourceValue;

private:

};

//---------------------------------------------------------------------------
// Neighbor の比較関数
//---------------------------------------------------------------------------
// 降順ソート
// > 0 (正)    Item1 が Item2 より小さい
//   0    Item1 と Item2 が等しい
// < 0 (負)    Item1 が Item2 より大きい
int __fastcall CompareNeighbor(void *Item1, void *Item2)
{
    if (TCFbEToolkit::GetToolkit()->Equals(((TCFbENeighbor*)Item1)->GetSimilarity(), ((TCFbENeighbor*)Item2)->GetSimilarity())) {
        return 0;
    } else if ( ((TCFbENeighbor*)Item1)->GetSimilarity() < ((TCFbENeighbor*)Item2)->GetSimilarity() ) {
        return 1;
    } else {
        return -1;
    }
}

//---------------------------------------------------------------------------
#endif
